Quassel IRC - Bug #158

Handle ASCII control codes sanely
Description

Codes below 0x20 are ASCII control codes. If somebody send one of these via IRC (that just happened for some strange reason),
QString converts those to funny-looking characters.

We should think about a way to display these more sanely, maybe using the "standard" notation "H for backspace etc. (but be sure
to distinguish that from somebody sending *H literally).

History

#1 - 12/28/2008 01:50 AM - Sputnick
- Priority changed from High to Normal

#2 - 10/05/2012 11:32 PM - Gallaecio

| was going to give this a try, but I've not been able to reproduce it... ... because | could not figure out how to write ASCII characters in Linux given
their value.

Anyway, since it's been 4 years since the last update, is this bug still valid?

#3 - 10/06/2012 12:01 PM - Anonymous
- Version set to 0.8-pre

- OS set to Any

Yes, this is still valid; Easiest way for me is to fire up ii and e.g. “echo -e 'fo0\010bar\007' >in".

#4 - 10/11/2012 09:45 PM - Anonymous

- Target version set to Some future release

MR 153

#5 - 12/01/2012 06:11 PM - Gallaecio
- File 0001-An-UTF-8-character-is-now-used-to-represent-the-ASCl.patch added
I've written a patch to replace the control characters by an UTF-8 character that represents them visually.
Also, these are in-depth details on the steps to reproduce the issue, just in case:
1. From Quassel, connect to the room #quassel-issue158 in FreeNode.
2. Install fii’.
3. Run it. For example:
$ ii -1 . -s 83.170.94.214 -p 6665 -n QuassellIssuel58
4. From a different terminal, enter the directory generated (‘83.170.94.214’) and run:
$ echo "/j #quassel-issuelb58" > in
$ cd \#quassel-issuel58/

$ echo -e "foo\007bar\010" > in

5. Watch the result in Quassel.
Expected result: meaninful representation of the codes.
Actual result: meaningless characters.

To print the whole list of control codes, use the following script:
for i in {0..31} 127

do
hex=$ (echo ""$i" "16" o p" | dc)

echo -e "$(printf "$03x\n" Ox$hex). fool\\x$ (printf "%02x" Ox$hex)bar" > "$1";

done
Run it followed by the path to the target ‘in’ file:
$ ./script.sh "83.170.94.214/#quassel-issuel58/in"

#6 - 12/01/2012 06:16 PM - Gallaecio

Ups, | see there is already a fix, so nevermind about the patch.

#7 - 02/20/2013 08:01 PM - Anonymous

- Status changed from New to Resolved

- Assignee set to Anonymous

- Target version changed from Some future release to 0.9.0

- Version changed from 0.8-pre to 0.3.0.x

Merged in 4676ff82af669595edaf090c97a28161d67782a1

Files

0001-An-UTF-8-character-is-now-used-to-represent-the-ASCl.patch  3.54 KB 12/01/2012
